using RaftModLoader;
using UnityEngine;
using HMLLibrary;
using HarmonyLib;
using System.Reflection;

public class PickupLabels : Mod
{
    Harmony harmony;
    public static CanvasHelper Canvas => ComponentManager<CanvasHelper>.Value;

    public void Start()
    {
        harmony = new Harmony("com.tamj0rd2.PickupLabels");
        harmony.PatchAll(Assembly.GetExecutingAssembly());
        Debug.Log("Mod PickupLabels has been loaded!");
    }

    public void OnModUnload()
    {
        harmony.UnpatchAll(harmony.Id);
        Destroy(gameObject);
        Debug.Log("Mod PickupLabels has been unloaded!");
    }
}

[HarmonyPatch(typeof(Pickup), "Update")]
public class Patch_LookingUpdate
{
    static bool shown = false;
    static void Postfix(Pickup __instance)
    {
        if (Helper.HitAtCursor(out var raycastHit, Player.UseDistance, LayerMasks.MASK_Item) && raycastHit.transform.tag == "PickupHook")
        {   
            var item = raycastHit.transform.GetComponentInParent<PickupItem>();

            if (item.pickupItemType == PickupItemType.Default) {
                __instance.DisplayPickupName(true);
                shown = true;
                return;
            }
        }

        if (shown)
        {
            PickupLabels.Canvas.displayTextManager.HideDisplayTexts();
            shown = false;
        }
    }
}
